﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace pr215_1
{
    class Program
    {
        unsafe static void Main()
        {
            // Переменные:
            int x = 100, y = 200, z = 300;
            // Массив указателей на целочисленные значения: 
            int*[] nums = new int* [3];
            // Значение первого элемента массива: 
            nums[0] = &x;
            // Значение второго элемента массива: 
            nums[1] = &y;
            // Значение третьего элемента массива: 
            nums[2] = &z;
            // Отображение значений переменных:
            Console.WriteLine("Числа: {0}, {1} и {2}", 
                nums[0][0], *nums[1], nums[2][0]);
            // Массив указателей на символьные значения: 
            char*[] symbs = new char* [3];
            // Значение первого элемента массива: 
            symbs[0] = (char*)&x;
            // Значение второго элемента массива: 
            symbs[1] = (char*)&y;
            // Значение третьего элемента массива: 
            symbs[2] = (char*)&z;
            // Символьная переменная: 
            char s = 'A';
            // Заполнение значениями области памяти,
            // выделенной под переменные:
            for(int i = 0; i < symbs.Length; i++) {
                for(int j = 0; j < sizeof(int)/sizeof(char); j++) {
                    // В блок памяти записывается значение: 
                    symbs[i][j] = s;
                    // Новое значение символьной переменной: 
                    s++;
                    // Отображение значения из блока памяти:
                    Console.Write(symbs[i][j] + " ");
                }
                Console.WriteLine();
            }
            // Проверка результата:
            Console.WriteLine("Числа: {0}, {1} и {2}", x, y, z);
            Console.WriteLine("Проверка: {0}, {1} и {2}", 
                nums[0][0], *nums[1], nums[2][0]); 
            Console.WriteLine("Еще раз: {0}, {1} и {2}",
                *(int*)symbs[0], *(int*)symbs[1],*(int*)symbs[2]);
            Console.WriteLine("Для сравнения: {0}, {1} и {2}",
                *symbs[0], *symbs[1], *symbs[2]);
        }
    }
}
